#!/usr/bin/perl

use lib qw(./lib);
require CDB_Perl::Read;

#-----変数--------------------------

$db='postal.cdb';
$maxsize=1000;

%PREF=(
'1' => '北海道',
'2' => '青森県',
'3' => '岩手県',
'4' => '秋田県',
'5' => '宮城県',
'6' => '山形県',
'7' => '福島県',
'8' => '茨城県',
'9' => '栃木県',
'10' => '群馬県',
'11' => '埼玉県',
'12' => '千葉県',
'13' => '東京都',
'14' => '神奈川県',
'15' => '新潟県',
'16' => '富山県',
'17' => '石川県',
'18' => '福井県',
'19' => '長野県',
'20' => '山梨県',
'21' => '静岡県',
'22' => '愛知県',
'23' => '岐阜県',
'24' => '三重県',
'25' => '滋賀県',
'26' => '京都府',
'27' => '大阪府',
'28' => '兵庫県',
'29' => '奈良県',
'30' => '和歌山県',
'31' => '鳥取県',
'32' => '島根県',
'33' => '岡山県',
'34' => '広島県',
'35' => '山口県',
'36' => '香川県',
'37' => '徳島県',
'38' => '愛媛県',
'39' => '高知県',
'40' => '福岡県',
'41' => '大分県',
'42' => '佐賀県',
'43' => '長崎県',
'44' => '宮崎県',
'45' => '熊本県',
'46' => '鹿児島県',
'47' => '沖縄県',
);

#-----------------------------------


if($ENV{'REQUEST_METHOD'} eq "POST"){
	if($ENV{'CONTENT_LENGTH'}>$maxsize){&error("投稿量が多すぎます。");}
		read(STDIN,$buff,$ENV{'CONTENT_LENGTH'});
	}
else{
	$buff=$ENV{'QUERY_STRING'};
}

if($buff){
	&decode;
}

sub decode{
	my(@pairs,$pair,$value,$name);
	@pairs=split(/&/,$buff);
	foreach $pair (@pairs){
		($name,$value)=split(/=/,$pair);
		$value=~tr/+/ /;
		$value=~s/%([a-fA-F0-9][a-fA-F0-9])/pack("H2",$1)/eg;
		$value=~s/&//g;
		$value=~s/"//g;
		$value=~s/'//g;
		$value=~s/<//g;
		$value=~s/>//g;
		$value=~s/\x0D\x0A//g;
		$value=~s/\x0D//g;
		$value=~s/\x0A//g;
		$FORM{$name}=$value;
	}

}


&Search;

sub Search{
my($rcdb,$result,$dum,$area,$address,$address2,$pref,@keys,$flag);
if($FORM{'code'} eq ""){
	&error("郵便番号が入力されていません。");
}
if(!-e $db){
	&error("postal.cdbがありません。");
}

$rcdb = CDB_Perl::Read->new($db);

$result = $rcdb->get_value($FORM{'code'});

if(!$result){
	&error("入力された郵便番号は存在しません。");
}

($dum,$pref,$address,$address2)=split(/,/,$result);

@keys=keys %PREF;
$flag=0;
foreach(@keys){
	if($pref eq $PREF{$_}){
		$area=$_;
		$flag=1;
		last;
	}
}
if(!$flag){
	$area="";
}

print <<EOM;
Content-type: text/html

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title></title>
<style type="text/css">
body{margin:0px;}
</style>
</head>
EOM

print "<body onload=\"parent.ShowData('$FORM{'act'}','$area','$address$address2')\">\n";

print <<EOM;
</body>
</html>
EOM
exit;

}

sub error{
print <<EOM;
Content-type: text/html

<html>
<head>
<meta http-equiv="Content-Type" content="text/html; charset=utf-8">
<title></title>
<style type="text/css">
body{margin:0px;font-size:10pt;color:#ff0000}
</style>
</head>
<body>
EOM

print $_[0];

print <<EOM;
</body>
</html>
EOM
exit;
}
exit;
